<%
Sub listAppointments(inReadPage)

  Dim lStrPageName

  On Error Resume Next

  lStrPageName = Request.ServerVariables("URL")
  p = InstrRev(lStrPageName, "/")
  If p <> 0 Then lStrPageName = Right(lStrPageName, Len(lStrPageName) - p)

  dy = Mid(mdy, 4, 2)
  mo = Left(mdy, 2)
  yr = Right(mdy, 4)

  If (dy = "") Or (mo = "") Or (yr = "") Then
    dy = Day(Date) : mo = Month(Date) : yr = Year(Date)
    mdy = Right("0" & mo, 2) & "/" & Right("0" & dy, 2) & "/" & yr
  End If

  rwbc MMDDYYYYTEXT & COLONSPACETEXT

  rwbc "<input type='text' name='mdy' format='NN\/NN\/NNNN' value='" & displayEncode(mdy) & "' emptyok='true'/>"

  rwc "<do type='accept' label='" & GOTEXT & "'>"

    rwc "<go href='" & lStrPageName & "' method='get'>"

      rwc "<postfield name='mb' value='" & mb & "'/>"
      rwc "<postfield name='fn' value='" & fn & "'/>"
      rwc "<postfield name='mdy' value='$(mdy)'/>"

    rwc "</go>"

  rwc "</do>"

  If validDate(dy, mo, yr) Then

    Set objMessages = objFolder.Messages

    objMessages.Sort 1, &H00610040

    Set myFilter = objMessages.Filter

    myStartDate = DateSerial(yr, mo, dy) + TimeSerial(0, 0, 1)

    writeTitle FormatDateTime(myStartDate, vbLongDate)

    'Starting Date = CDO's ends on or after date
    myFilter.Fields.Add &H00610040, myStartDate

    'Ending Date = CDO's starts on or before date
    myEndDate = myStartDate - TimeSerial(0, 0, 1) + TimeSerial(23, 59, 59)
    myFilter.Fields.Add &H00600040, myEndDate

    numberOfMessages = 0
    For Each objMessage In objMessages
      numberOfMessages = numberOfMessages + 1
    Next

    If mn > numberOfMessages Then mn = ((Int(numberOfMessages / APPOINTMENTSPERPAGE) - 1) * APPOINTMENTSPERPAGE) + 1
    If mn < 1 Then mn = 1

    firstMessage = mn
    If mn + (APPOINTMENTSPERPAGE - 1) > numberOfMessages Then
      lastMessage = numberOfMessages
    Else
      lastMessage = mn + (APPOINTMENTSPERPAGE - 1)
    End If

    If numberOfMessages > 0 Then
      writeTitle firstMessage & "-" & lastMessage & " " & OFTEXT & " " & numberOfMessages
    End If

    noLineBreaks = True
    t = False

    If mn > 1 Then
      oldmn = mn : mn = 1
      writeLink lStrPageName, TOPTEXT, OPWMDY + OPWFN + OPWMN
      mn = oldmn
      t = True
    End If

    If mn > APPOINTMENTSPERPAGE Then
      oldmn = mn : mn = mn - APPOINTMENTSPERPAGE
      writeLink lStrPageName, PREVIOUSTEXT & " " & APPOINTMENTSPERPAGE, OPWMDY + OPWFN + OPWMN
      mn = oldmn
      t = True
    End If

    If mn <= (numberOfMessages - APPOINTMENTSPERPAGE) Then
      oldmn = mn : mn = mn + APPOINTMENTSPERPAGE
      writeLink lStrPageName, NEXTTEXT & " " & APPOINTMENTSPERPAGE, OPWMDY + OPWFN + OPWMN
      mn = oldmn
      t = True
    End If

    If t Then rwbc ""
    noLineBreaks = False

    messageCounter = 0
    messagesDisplayed = 0
    For Each objMessage In objMessages

      If (messageCounter >= firstMessage - 1) And (messageCounter <= lastMessage - 1) Then

        display = FormatDateTime(objMessage.Fields("{0220060000000000C000000000000046}0x820D"), 3)
        display = display & "_"
        subject = objMessage.Subject
        If subject = "" Then subject = NONETEXT
        display = display & Left(subject & "        ", FOLDERSUBJECTWIDTH)
        display = displayEncode(display)
        mi = objMessage.ID
        writeLink inReadPage, display, OPWFN + OPWMN + OPWMI + OPWMDY
        messagesDisplayed = messagesDisplayed + 1
        If messagesDisplayed >= APPOINTMENTSPERPAGE Then Exit For

      End If

      messageCounter = messageCounter + 1

    Next

    Set myFilter = Nothing
    Set objMessages = Nothing

    If messageCounter = 0 Then
      rwbc NOAPPOINTMENTSFORSELECTEDDAYTEXT
    End If

  Else
    rwbc INVALIDDATETEXT
  End If

End Sub

Sub listContacts(inReadPage)

  Dim lStrPageName

  On Error Resume Next

  lStrPageName = Request.ServerVariables("URL")
  p = InstrRev(lStrPageName, "/")
  If p <> 0 Then lStrPageName = Right(lStrPageName, Len(lStrPageName) - p)

  myFilter = Request.QueryString("filter")

  writeTitle FILTERTEXT & COLONSPACETEXT

  rwbc "<input type='text' name='filter' value='" & myFilter & "' emptyok='true'/>"

  writeLink lStrPageName, OKTEXT, OPWFN + OPWDFILTER

  Set objMessages = objFolder.Messages

  If myFilter <> "" Then

    Set objFilter = objMessages.Filter

    ' Add a filter for Name
    objFilter.Fields(&H0E1D001F) = myFilter

  End If

  objMessages.Sort 1, &H0E1D001F

  n = 0
  For Each objMessage In objMessages

    mi = objMessage.ID
    writeLink inReadPage, objMessage.Subject, OPWFN + OPWMI
    n = n + 1
    If n >= ADDRESSESPERPAGE Then Exit For

  Next

  If n >= ADDRESSESPERPAGE Then

    rwbc ""
    rwbc DISPLAYLIMITEDTOTEXT & " " & ADDRESSESPERPAGE & " " & ENTRIESTEXT

  End If

End Sub

Sub listMessages(inReadPage)

  Dim lStrPageName

  lStrPageName = Request.ServerVariables("URL")
  p = InstrRev(lStrPageName, "/")
  If p <> 0 Then lStrPageName = Right(lStrPageName, Len(lStrPageName) - p)

  noLineBreaks = True

  If mn > 1 Then
    oldmn = mn : mn = 1
    writeLink lStrPageName, TOPTEXT, OPWFN
    mn = oldmn
  End If

  If mn > MESSAGESPERPAGE Then
    oldmn = mn : mn = mn - MESSAGESPERPAGE
    writeLink lStrPageName, PREVIOUSTEXT & " " & MESSAGESPERPAGE, OPWFN + OPWMN
    mn = oldmn
  End If

  noLineBreaks = False

  If mn <= (numberOfMessages - MESSAGESPERPAGE) Then
    oldmn = mn : mn = mn + MESSAGESPERPAGE
    writeLink lStrPageName, NEXTTEXT & " " & MESSAGESPERPAGE, OPWFN + OPWMN
    mn = oldmn
  End If

  writeUnderline

  objMessages.Sort(2)

  pg = 1

  For n = firstMessage to lastMessage

    Set objMessage = objMessages(n)

    If objMessage.Unread Then
      display = "*"
    Else
      display = "_"
    End If

    ' Are we in Sent Items?
    If checkTopFolder(objSession.GetFolder(objMessage.FolderID), 3) Then
      display = display & getMessageRecipient(objMessage)
    Else
      display = display & getMessageSender(objMessage)
    End If

    display = Left(display & "        ", FOLDERSENDERWIDTH)
    display = display & "_"
    subject = objMessage.Subject
    If subject = "" Then subject = NONETEXT
    display = display & Left(subject & "        ", FOLDERSUBJECTWIDTH)
    mi = objMessage.ID
    writeLink inReadPage, display, OPWFN + OPWMN + OPWMI

  Next

End Sub

Sub listNotes(inReadPage)

  Dim lStrPageName

  lStrPageName = Request.ServerVariables("URL")
  p = InstrRev(lStrPageName, "/")
  If p <> 0 Then lStrPageName = Right(lStrPageName, Len(lStrPageName) - p)

  Set objMessages = objFolder.Messages

  ' Sort Notes in ascending order of body text
  objMessages.Sort 1, &H1000001F

  numberOfMessages = 0
  For Each objMessage In objMessages
    numberOfMessages = numberOfMessages + 1
  Next

  If mn > numberOfMessages Then mn = ((Int(numberOfMessages / NOTESPERPAGE) - 1) * NOTESPERPAGE) + 1
  If mn < 1 Then mn = 1

  firstMessage = mn
  If mn + (NOTESPERPAGE - 1) > numberOfMessages Then
    lastMessage = numberOfMessages
  Else
    lastMessage = mn + (NOTESPERPAGE - 1)
  End If

  If numberOfMessages > 0 Then
    writeTitle firstMessage & "-" & lastMessage & " " & OFTEXT & " " & numberOfMessages
  End If

  noLineBreaks = True
  t = False

  If mn > 1 Then
    oldmn = mn : mn = 1
    writeLink lStrPageName, TOPTEXT, OPWFN + OPWMN
    mn = oldmn
    t = True
  End If

  If mn > NOTESPERPAGE Then
    oldmn = mn : mn = mn - NOTESPERPAGE
    writeLink lStrPageName, PREVIOUSTEXT & " " & NOTESPERPAGE, OPWFN + OPWMN
    mn = oldmn
    t = True
  End If

  If mn <= (numberOfMessages - NOTESPERPAGE) Then
    oldmn = mn : mn = mn + NOTESPERPAGE
    writeLink lStrPageName, NEXTTEXT & " " & NOTESPERPAGE, OPWFN + OPWMN
    mn = oldmn
    t = True
  End If

  If t Then rwbc ""
  noLineBreaks = False

  writeUnderline

  messageCounter = 0
  messagesDisplayed = 0
  For Each objMessage In objMessages
    If (messageCounter >= firstMessage - 1) And (messageCounter <= lastMessage - 1) Then
      display = ""
      display = objMessage.Subject
      If display = "" Then display = NONETEXT
      mi = objMessage.ID
      writeLink inReadPage, display, OPWFN + OPWMI + OPWMN
      messagesDisplayed = messagesDisplayed + 1
      If messagesDisplayed >= NOTESPERPAGE Then Exit For
    End If
    messageCounter = messageCounter + 1
  Next

  Set objMessages = Nothing

  If messageCounter = 0 Then
    rwbc NONETEXT
  End If

End Sub

Sub listPosts(inReadPage)

  Dim lStrPageName

  On Error Resume Next

  lStrPageName = Request.ServerVariables("URL")
  p = InstrRev(lStrPageName, "/")
  If p <> 0 Then lStrPageName = Right(lStrPageName, Len(lStrPageName) - p)

  noLineBreaks = True

  If mn > 1 Then
    writeLink lStrPageName, TOPTEXT, OPWFN
  End If

  If mn > MESSAGESPERPAGE Then
    oldmn = mn : mn = mn - MESSAGESPERPAGE
    writeLink lStrPageName, PREVIOUSTEXT & " " & MESSAGESPERPAGE, OPWFN + OPWMN
    mn = oldmn
  End If

  If mn <= (numberOfMessages - MESSAGESPERPAGE) Then
    oldmn = mn : mn = mn + MESSAGESPERPAGE
    writeLink lStrPageName, NEXTTEXT & " " & MESSAGESPERPAGE, OPWFN + OPWMN
    mn = oldmn
  End If

  rwbc ""
  noLineBreaks = False

  writeUnderline

  objMessages.Sort(2)

  n = 0

  For o = firstMessage to lastMessage

    n = n + 1

    Set objMessage = objMessages(o)

    display = ""

    If objMessage.Unread Then
      display = "*"
    Else
      display = "_"
    End If
    display = display& getMessageSender(objMessage)
    display = Left(display & "        ", FOLDERSENDERWIDTH)
    display = display & "_"

    subject = objMessage.Subject
    If subject = "" Then subject = NONETEXT
    display = display & Left(subject & "        ", FOLDERSUBJECTWIDTH)
    tmpBoldFlag = 0
    If objMessage.Unread Then tmpBoldFlag = OPWBOLD
    mi = objMessage.ID
    writeLink inReadPage, display, OPWFN + OPWMN + OPWMI + tmpBoldFlag

  Next

End Sub

Sub listTasks(inReadPage)

  Dim lStrPageName

  On Error Resume Next

  lStrPageName = Request.ServerVariables("URL")
  p = InstrRev(lStrPageName, "/")
  If p <> 0 Then lStrPageName = Right(lStrPageName, Len(lStrPageName) - p)

  oldmp = mp
  If mp = "" Then
    mp = 1
    writeLink lStrPageName, LISTALLTASKSTEXT, OPWFN + OPWMP
    blnShowAllTasks = False
  Else
    mp = ""
    writeLink lStrPageName, LISTOPENTASKSTEXT, OPWFN + OPWMP
    blnShowAllTasks = True
  End If
  mp = oldmp

  Set objMessages = objFolder.Messages

  ' Are we showing ALL Tasks, or only the incomplete ones?
  If Not blnShowAllTasks Then
    Set locObjFilter = objMessages.Filter
    locObjFilter.Fields.Add "{0320060000000000C000000000000046}0x811C", vbBoolean, False
  End If

  ' Get GUID-based Due Date property ID
  Set objTaskMessage = objFolder.Messages.GetFirst()

  ' Can't attempt to sort if there are no Tasks
  If Not(objTaskMessage Is Nothing) Then
    Set objFields = objTaskMessage.Fields
    If SHOWERRORS Then On Error Resume Next
    Set objDueDateField = objFields.Item("{0320060000000000C000000000000046}0x8105")
    If Err.Number <> 0 Then
      objTaskMessage.Fields.Add "{0320060000000000C000000000000046}0x8105", vbLong, 0
      Set objDueDateField = objFields.Item("{0320060000000000C000000000000046}0x8105")
    End If
    If SHOWERRORS Then On Error Goto 0
    strDueDateField =  objDueDateField.ID
    Set objDueDateField = Nothing
    Set objFields = Nothing
    Set objTaskMessage = Nothing

    ' Sort Tasks in descending order of Due Date
    objMessages.Sort 2, strDueDateField
  End If

  numberOfMessages = 0
  For Each objMessage In objMessages
    numberOfMessages = numberOfMessages + 1
  Next

  If mn > numberOfMessages Then mn = ((Int(numberOfMessages / TASKSPERPAGE) - 1) * TASKSPERPAGE) + 1
  If mn < 1 Then mn = 1

  firstMessage = mn
  If mn + (TASKSPERPAGE - 1) > numberOfMessages Then
    lastMessage = numberOfMessages
  Else
    lastMessage = mn + (TASKSPERPAGE - 1)
  End If

  If numberOfMessages > 0 Then
    writeTitle firstMessage & "-" & lastMessage & " " & OFTEXT & " " & numberOfMessages
  End If

  noLineBreaks = True
  t = False

  If mn > 1 Then
    oldmn = mn : mn = 1
    writeLink lStrPageName, TOPTEXT, OPWFN + OPWMN + OPWMP
    mn = oldmn
    t = True
  End If

  If mn > TASKSPERPAGE Then
    oldmn = mn : mn = mn - TASKSPERPAGE
    writeLink lStrPageName, PREVIOUSTEXT & " " & TASKSPERPAGE, OPWFN + OPWMN + OPWMP
    mn = oldmn
    t = True
  End If

  If mn <= (numberOfMessages - TASKSPERPAGE) Then
    oldmn = mn : mn = mn + TASKSPERPAGE
    writeLink lStrPageName, NEXTTEXT & " " & TASKSPERPAGE, OPWFN + OPWMN + OPWMP
    mn = oldmn
    t = True
  End If

  If t Then rwbc ""
  noLineBreaks = False

  writeUnderline

  messageCounter = 0
  messagesDisplayed = 0
  For Each objMessage In objMessages
    If (messageCounter >= firstMessage - 1) And (messageCounter <= lastMessage - 1) Then

      display = ""
      display = objMessage.Subject
      If display = "" Then display = NONETEXT
      mi = objMessage.ID
      writeLink inReadPage, display, OPWFN + OPWMI + OPWMN + OPWMP
      messagesDisplayed = messagesDisplayed + 1
      If messagesDisplayed >= TASKSPERPAGE Then Exit For

    End If
    messageCounter = messageCounter + 1
  Next

  Set objMessages = Nothing

  If messageCounter = 0 Then
    writeUnderline
    rwbc NONETEXT
  End If

End Sub
%>
